#include <stdio.h>
#include <stdlib.h>

int main()
{
    int h,n;
    scanf("%d%d",&h,&n);
    int vodopad[h][n];
    int i,j,k,l,lm;
    for(i=0;i<h;i++)
    {
        for(j=0;j<n;j++)
        {
            scanf("%d",&vodopad[i][j]);
        }
    }
    int linija[n];
    for(i=0;i<n;i++)
    {
        linija[i]=1;
    }
    for(i=0;i<h;i++)
    {
        if(vodopad[i][0]==0)
        {
            linija[1]+=linija[0];
            linija[0]=0;
            l=0;
            lm=1;
            while(l==0)
                {
                    if(vodopad[i][lm]==0)
                    {
                        linija[lm+1]+=linija[lm];
                        linija[lm]=0;
                    }
                    else
                        l++;
                    lm++;
                }
        }
        if(vodopad[i][n-1]==0)
        {
            linija[n-2]+=linija[n-1];
            linija[n-1]=0;
            l=0;
            lm=n-2;
            while(l==0)
                {
                    if(vodopad[i][lm]==0)
                    {
                        linija[lm-1]+=linija[lm];
                        linija[lm]=0;
                    }
                    else
                        l++;
                    lm--;
                }
        }





        for(j=0;j<n;j++)
        {
            if(vodopad[i][j]==0)
            {
                if(linija[j]%2!=0)
                {
                    if(i%2==0)
                    {
                        linija[j-1]++;
                        linija[j]--;
                    }
                    else
                    {
                        linija[j+1]++;
                        linija[j]--;
                    }
                }
                if(linija[j]!=0)
                {
                    linija[j-1]+=linija[j]/2;
                    l=0;
                    lm=j-1;
                    while(l==0&&lm!=0)
                    {
                        if(vodopad[i][lm]==0)
                        {
                            linija[lm-1]+=linija[lm];
                            linija[lm]=0;
                        }
                        else
                            l++;
                        lm--;
                    }
                    if(lm==0)
                    {
                        if(vodopad[i][0]==0)
                        {
                            linija[j+1]+=linija[0];
                            linija[0]=0;
                        }
                    }
                    linija[j+1]+=linija[j]/2;
                    l=0;
                    lm=j+1;
                    while(l==0)
                    {
                        if(vodopad[i][lm]==0)
                        {
                            linija[lm+1]+=linija[lm];
                            linija[lm]=0;
                        }
                        else
                            l++;
                        lm++;
                    }
                    linija[j]=0;
                }
            }
        }
    }
    for(i=0;i<n;i++)
    {
        printf("%d ",linija[i]);
    }
}